SortedTitles = SortedTitles or {}
SortedTitles.name = "SortedTitles"
SortedTitles.version = "1.1"
SortedTitles.originalUpdateTitleDropdownTitles = STATS.UpdateTitleDropdownTitles
SortedTitles.originalUpdateTitleDropdownSelection = STATS.UpdateTitleDropdownSelection

function SortedTitles.UpdateTitleDropdownTitles(self, dropdown)
    dropdown:ClearItems()

    -- "No Title" item
    dropdown:AddItem(ZO_ComboBox:CreateItemEntry(GetString(SI_STATS_NO_TITLE), function() SelectTitle(nil) end), ZO_COMBOBOX_SUPRESS_UPDATE)
    
    -- Gather titles
    local titles = {}  
    for i = 1, GetNumTitles() do titles[zo_strformat(GetTitle(i), GetRawUnitName("player"))] = i end
    table.sort(titles)
    
    -- table sorting snippet from lua.org page
    local function pairsByKeys(t, f)
        local a = {}
        for n in pairs(t) do table.insert(a, n) end
        table.sort(a, f)
        local i = 0      -- iterator variable
        local iter = function ()   -- iterator function
            i = i + 1
            if a[i] == nil then return nil
            else return a[i], t[a[i]]
            end
        end
        return iter
    end
    
    -- add items from sorted
    for title, index in pairsByKeys(titles) do
        dropdown:AddItem(ZO_ComboBox:CreateItemEntry(title, function() SelectTitle(index) end), ZO_COMBOBOX_SUPRESS_UPDATE)
    end
    
    dropdown:UpdateItems()
    self:UpdateTitleDropdownSelection(dropdown)
end

-- Old function from before 8.2.5
-- New function gets the selected item by string value, new function selects by index (which is scambled due to the sorting)
function SortedTitles.UpdateTitleDropdownSelection(self, dropdown)
    local currentTitleIndex = GetCurrentTitleIndex()
    if currentTitleIndex then
        dropdown:SetSelectedItemText(zo_strformat(GetTitle(currentTitleIndex), GetRawUnitName("player")))
    else
        dropdown:SetSelectedItemText(GetString(SI_STATS_NO_TITLE))
    end
end

function SortedTitles.OnAddonLoaded(event, addonName)
    if addonName ~= SortedTitles.name then return end
    STATS.UpdateTitleDropdownTitles = SortedTitles.UpdateTitleDropdownTitles
	STATS.UpdateTitleDropdownSelection = SortedTitles.UpdateTitleDropdownSelection
    GAMEPAD_STATS.UpdateTitleDropdownTitles = SortedTitles.UpdateTitleDropdownTitles
	GAMEPAD_STATS.UpdateTitleDropdownSelection = SortedTitles.UpdateTitleDropdownSelection
end
EVENT_MANAGER:RegisterForEvent(SortedTitles.name, EVENT_ADD_ON_LOADED, SortedTitles.OnAddonLoaded)